Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2339 by niro, Fri Jan 3 14:20:42 2014 UTC revision 2421 by niro, Tue Jan 7 13:50:50 2014 UTC
# Line 9  Line 9 
9    
10  # ignore the environment  # ignore the environment
11  LC_ALL=C  LC_ALL=C
12    # include dir
13  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
14    
15  # configuration  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  if [ -e %SYSCONFDIR%/installer.conf ]  # -> now in images.conf
17  then  CURRENTLINE=0
18   source %SYSCONFDIR%/installer.conf  
19  else  die()
20   die "/etc/installer.conf not found"  {
21  fi   echo "Error: $@"
22     exit 1
23    }
24    
25  #images: (get ${CDIMAGENAME})  # load common includes
26    for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40    # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41    # -> now in images.conf
42    CDIMAGENAME=""
43    TOTALLINES=""
44    CURRENTLINE=0
45  if [ -e /mnt/cdrom/system/images.conf ]  if [ -e /mnt/cdrom/system/images.conf ]
46  then  then
47   source /mnt/cdrom/system/images.conf   source /mnt/cdrom/system/images.conf
48     # check if all required variables are set
49     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
50     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
51  else  else
52   die "/mnt/cdrom/system/images.conf not found"   die "/mnt/cdrom/system/images.conf not found"
53  fi  fi
54    
 # includes  
 source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  
   
55  ### System/Config Version  ### System/Config Version
56  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
57  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59  CDPATH="${DEFAULT_CDPATH}"  # some sane defaults
60  INSTALLPATH="${DEFAULT_INSTALLPATH}"  CDROOT="${DEFAULT_CDROOT}"
61    INSTALLROOT="${DEFAULT_INSTALLROOT}"
62  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  KERNELPKG="${DEFAULT_KERNELPKG}"
63  CURRENTLINE=0  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 #TOTALLINES=11072 # -> now in images.conf  
   
 # standard kernel opts  
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
69  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75  die()  trap_exit()
76  {  {
77   echo "Error: $@"   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
78     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
79     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
80     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
81     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
82    
83     echo $"Installation aborted."
84   exit 1   exit 1
85  }  }
86    
87  dialog_die()  dialog_die()
88  {  {
89   ERROR=$1   ERROR="$1"
90   RETVAL=$?   RETVAL="$?"
91   dialog_install_failure   dialog_install_failure
92   exit 1   exit 1
93  }  }
94    
95  dialog_warning()  dialog_warning()
96  {  {
97   dialog \   local retval
98   --backtitle "${TITLE}" \  
99   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
100   --defaultno \   retval=$?
101   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
102   then   then
103   clear   clear
104   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
105   exit 1   exit 1
106   fi   fi
107  }  }
108    
109  dialog_setup_hdd_info()  dialog_setup_hdd_info()
110  {  {
111   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
112    
113   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
114   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
115  }  }
116    
117  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
118  {  {
119   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
120    
121   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
122   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
123  }  }
124    
125  dialog_setup_system_menu()  dialog_setup_system_menu()
126  {  {
127   local i   local mode
128     local retval
129    
130   i=$(dialog \   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
131   --backtitle "${TITLE}" \   $"1:Automatic setup (recommended)" \
132   --title "[ Festplatten Partitionierung ]" \   ":" \
133   --cancel-label "Abbrechen" \   $":\Z1Expert modes:\Zn" \
134   --ok-label "Weiter" \   $"2:Common IDE-disk (manual setup)")
135   --stdout \   retval=$?
136   --colors \   [[ ${retval} -eq 1 ]] && return 1
137   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   if [[ ${retval} -eq 0 ]]
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
138   then   then
139   case "${i}" in   case "${mode}" in
140   "1") run_install_auto ;;   "1") run_install_auto ;;
141           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
142   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
143   esac   esac
144   fi   fi
# Line 170  dialog_setup_system_menu() Line 146  dialog_setup_system_menu()
146    
147  dialog_hardware_detection()  dialog_hardware_detection()
148  {  {
149   local i   local message
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
150    
151   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
152    
153   echo "dialog \\"  > ${hwtmp}   message+=$"Harddrives:\n"
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
154    
155   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
156   then   then
157   for i in ${scsidisks}   for i in ${ALL_DISKS}
158   do   do
159   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn "
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
160   done   done
161     message+="\n"
162   fi   fi
163    
164   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
165   then   then
166   for i in ${idedisks}   message+="\n"
167     message+=$"Optical disk drives:\n"
168     for i in ${ALL_CDROMS}
169   do   do
170   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn"
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
171   done   done
172   fi   message+="\n"
   
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
173   fi   fi
174    
175   # other devices   # other devices
176   run_hardware_detection   run_hardware_detection
177   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
178   zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
179   rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
180   maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;   maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
181   *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;   *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
182   esac   esac
183   if [[ ${FORMFACTOR} = laptop ]]   if [[ ${FORMFACTOR} = laptop ]]
184   then   then
185   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"
186   fi   fi
187    
188   echo " \" 14 70" >> ${hwtmp}   messagebox -y 15 -h $"Detected hardware:" "${message}"
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
189  }  }
190    
191  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
192  {  {
193   local i   local i
194    
195   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
196   then   then
197   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
198   exit 1   exit 1
199   else   else
200    
# Line 265  dialog_setup_hdd_partitions_manuell() Line 205  dialog_setup_hdd_partitions_manuell()
205   echo "--stdout \\" >> /tmp/hddtmp.sh   echo "--stdout \\" >> /tmp/hddtmp.sh
206   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh
207    
208   for i in ${installdevs}   for i in ${ALL_DISKS}
209   do   do
210   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh
211   done   done
# Line 278  dialog_setup_hdd_partitions_manuell() Line 218  dialog_setup_hdd_partitions_manuell()
218   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
219   then   then
220   dialog_setup_hdd_info   dialog_setup_hdd_info
221   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
222   fi   fi
223   fi   fi
224  }  }
225    
226  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
227  {  {
228   local i   local i
229    
230   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
231   then   then
232   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
233   exit 1   exit 1
234   else   else
235    
# Line 303  dialog_setup_hdd_partitions_manuell_flas Line 240  dialog_setup_hdd_partitions_manuell_flas
240   echo "--stdout \\" >> /tmp/hddtmp.sh   echo "--stdout \\" >> /tmp/hddtmp.sh
241   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh   echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh
242    
243   for i in ${installdevs}   for i in ${ALL_DISKS}
244   do   do
245   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh   echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh
246   done   done
# Line 315  dialog_setup_hdd_partitions_manuell_flas Line 252  dialog_setup_hdd_partitions_manuell_flas
252   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
253   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
254   then   then
255   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
256   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
257     setup_hdd_partitions_auto
258   fi   fi
259   fi   fi
260  }  }
261    
262  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
263  {  {
264   local i   local bootdev
265    
266   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
267     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
268     # remove the boot device from ALL_DISKS if it was an usbstick
269     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
270   then   then
271   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
272   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
273   fi   fi
274     export ALL_CDROMS="$(get_hwinfo cdrom)"
275  }  }
276    
277  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 448  dialog_main() Line 362  dialog_main()
362   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
363   then   then
364   case ${METHOD} in   case ${METHOD} in
365           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
366   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
367   "3") install_do_reboot ;;   "3") install_do_reboot ;;
368   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 597  EOF Line 511  EOF
511   fi   fi
512  }  }
513    
514  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
515  {  {
516   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
517    
518   ## hdds partitionieren manuell   ## hdds partitionieren manual
519   cfdisk ${HDD} || dialog_die   cfdisk ${HDD} || dialog_die
520  }  }
521    
522  setup_hdd_format()  setup_hdd_format()
523  {  {
  mkswap ${SWAPHDD} || dialog_die  
  mke2fs -j -q ${BOOTHDD} || dialog_die  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
 }  
   
 setup_hdd_format_flash()  
 {  
524   mke2fs -j -q ${ROOTHDD} || dialog_die   mke2fs -j -q ${ROOTHDD} || dialog_die
525  }  }
526    
527  install_mount_rootfs()  install_mount_rootfs()
528  {  {
529   swapon ${SWAPHDD} || dialog_die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
530   mount ${ROOTHDD} ${INSTALLPATH} || dialog_die   install -d ${INSTALLROOT}/boot || dialog_die
531   install -d ${INSTALLPATH}/boot || dialog_die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || dialog_die  
  cd ${INSTALLPATH} || dialog_die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || dialog_die  
  install -d ${INSTALLPATH}/boot || dialog_die  
  cd ${INSTALLPATH} || dialog_die  
532  }  }
533    
534  install_system_image()  install_system_image()
535  {  {
536   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
537  }  }
538    
539  install_bootsector_chroot()  install_bootsector_chroot()
540  {  {
541   local my_roothdd   local my_roothdd
542   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
543   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
544    
545   # check for grub2   # check for grub2
546   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
547   then   then
548   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
549   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
550   then   then
551   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || dialog_die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
552   fi   fi
553    
554   # set kernelopts   # set kernelopts
555   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
556   then   then
557   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || dialog_die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
558   else   else
559   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || dialog_die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
560   fi   fi
561   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || dialog_die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
562   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || dialog_die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
563   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || dialog_die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
564   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || dialog_die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
565    
566   # grub-legacy   # grub-legacy
567   else   else
568   ### grubconf schreiben   ### grubconf schreiben
569   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
570    
571   #for alx only   #for alx only
572   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
573   then   then
574   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
575   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
576   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
577   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
578   fi   fi
# Line 705  install_bootsector_chroot() Line 593  install_bootsector_chroot()
593   echo "default 0" >> ${grubconf} || dialog_die   echo "default 0" >> ${grubconf} || dialog_die
594   echo "timeout 3" >> ${grubconf} || dialog_die   echo "timeout 3" >> ${grubconf} || dialog_die
595   # using current root password   # using current root password
596   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
597    
598   echo  >> ${grubconf} || dialog_die   echo  >> ${grubconf} || dialog_die
599   echo "# normal boot" >> ${grubconf} || dialog_die   echo "# normal boot" >> ${grubconf} || dialog_die
# Line 739  install_bootsector_chroot() Line 627  install_bootsector_chroot()
627   fi   fi
628    
629   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
630   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
631  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
632  root (hd0,0)  root (hd0,0)
633  setup (hd0)  setup (hd0)
# Line 750  CHROOTEOF Line 638  CHROOTEOF
638   fi   fi
639    
640   ## enter chroot   ## enter chroot
641   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
642   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
643   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
644   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
645   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
646   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
647   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
648   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
649  }  }
650    
651  is_initrd_supported()  is_initrd_supported()
652  {  {
653   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
654   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
655   return 1   return 1
656  }  }
657    
# Line 794  install_initrd_chroot() Line 682  install_initrd_chroot()
682   fi   fi
683    
684   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
685   install -d ${INSTALLPATH}/etc/modprobe.d || dialog_die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
686   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || dialog_die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
687    
688   # install an appropriate viafb.conf   # install an appropriate viafb.conf
689   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || dialog_die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
690    
691   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
692   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || dialog_die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
693    
694   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
695  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
696  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
697  exit 0  exit 0
698  CHROOTEOF  CHROOTEOF
699    
700   ## enters chroot   ## enters chroot
701   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
702   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
703   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
704   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
705   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
706   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
707   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
708   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
709  }  }
710    
711  is_uuid_supported()  is_uuid_supported()
712  {  {
713   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
714   then   then
715   # only detect uuids if supported   # only detect uuids if supported
716   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 858  install_system_settings() Line 746  install_system_settings()
746   # schreibe fstab   # schreibe fstab
747   if is_uuid_supported   if is_uuid_supported
748   then   then
749   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || dialog_die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die  
750   else   else
751   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || dialog_die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die  
752   fi   fi
753   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
754   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
755   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
756   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
757    
758   # install network config skeleton   # install network config skeleton
759   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || dialog_die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
760    
761   # intel framebufer quirk   # intel framebufer quirk
762   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 880  install_system_settings() Line 766  install_system_settings()
766   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
767   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
768   then   then
769   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || dialog_die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
770   fi   fi
771   fi   fi
772   fi   fi
773  }  }
774    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || dialog_die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || dialog_die  
 }  
   
775  install_umount_rootfs()  install_umount_rootfs()
776  {  {
777   cd /   cd /
778   umount ${INSTALLPATH}/boot || dialog_die   umount ${INSTALLROOT}/boot || dialog_die
779   umount ${INSTALLPATH} || dialog_die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || dialog_die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || dialog_die  
780  }  }
781    
782  install_do_reboot()  install_do_reboot()
# Line 926  run_install_normal() Line 792  run_install_normal()
792  {  {
793   dialog_hardware_detection   dialog_hardware_detection
794    
795   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
796   dialog_setup_hdd_format   dialog_setup_hdd_format
797   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
798   install_mount_rootfs   install_mount_rootfs
# Line 944  run_install_normal() Line 810  run_install_normal()
810   dialog_install_successful   dialog_install_successful
811  }  }
812    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
813  run_install_auto()  run_install_auto()
814  {  {
815   dialog_hardware_detection   dialog_hardware_detection
816    
817   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
818   dialog_setup_hdd_format   dialog_setup_hdd_format
819   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
820   install_mount_rootfs_flash   install_mount_rootfs
821   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
822    
823   dialog_install_settings   dialog_install_settings
824   sleep 1   sleep 1
825   install_system_settings_flash   install_system_settings
826   install_initrd_chroot   install_initrd_chroot
827    
828   dialog_install_bootsector   dialog_install_bootsector
829   install_bootsector_chroot   install_bootsector_chroot
830    
831   install_umount_rootfs_flash   install_umount_rootfs
832   dialog_install_successful   dialog_install_successful
833  }  }
834    
835    # set some proper traps
836    trap "trap_exit" SIGINT SIGQUIT
837    
838  dialog_main  dialog_main
839    
840  exit 0  exit 0

Legend:
Removed from v.2339  
changed lines
  Added in v.2421